; Performs arithmetic on registers

.include "shell.inc"

main:
	ldx #1
	jsr print_x
	
	; Increment X
	inx             ; X = X + 1
	jsr print_x     ; prints 01
	
	; Decrement X
	dex             ; X = X - 1
	jsr print_x     ; prints 00
	jsr print_newline
	
	; ADC adds a value and carry to A
	; Carry is a flag (a single bit) that
	; is added to A as well, so it must be
	; cleared with CLC.
	lda #3
	clc
	adc #4          ; A = A + 4 + carry
	jsr print_a     ; prints 07
	jsr print_newline
	
	; AND A with $F0
	lda #$34
	and #$F0        ; A = A AND $F0
	jsr print_a     ; prints 30
	
	; OR A with $02
	ora #$02        ; A = A OR $02
	jsr print_a     ; prints 32
	
	; Shift A left by 1 bit
	asl a           ; A = A * 2
	jsr print_a     ; prints 64
	jsr print_newline
	
	rts
