; Calls routines

.include "shell.inc"

main:
	; Calls routine do_something. When it
	; returns, execution continues just after
	; the JSR.
	jsr do_something
	
	; The value of routines is that they can be
	; called multiple times from anywhere, as if
	; their code were inserted in place of the
	; JSR.
	jsr do_something
	
	; We can pass values to routines using registers.
	; We can also get values back from the routine
	; the same way.
	lda #1
	ldx #2
	ldy #3
	jsr use_values
	jsr print_a ; print A after routine returns
	jsr print_newline
	
	; Routines can even call themselves!
	ldx #5
	jsr recursive
	
	rts

; Routine that can be called from other code
do_something:
	print_str "Doing something!"
	jsr print_newline
	
	; Routine is done, so return back to place
	; just after JSR that called this.
	rts

; This routine uses values passed to it
use_values:
	print_str "Using values: "
	jsr print_a
	jsr print_x
	jsr print_y
	jsr print_newline
	
	; Return the value 9 to caller
	lda #9
	rts

; This routine calls itself until X becomes 0
recursive:
	jsr print_x
	dex
	beq done
	jsr recursive
done:   rts
