; Saves and restores values on the stack

.include "shell.inc"

main:
	; Push some values on the stack
	lda #1
	pha             ; Push 01 on the stack
	lda #2
	pha             ; Push 02 on the stack
	
	; Pop them back off
	pla             ; Pop most recently pushed value into A
	jsr print_a     ; prints 02
	pla
	jsr print_a     ; prints 01
	jsr print_newline
	
	; The stack is useful for saving and restoring
	; registers in a routine.
	lda #1
	jsr routine
	jsr print_a     ; prints 01
	jsr print_newline
	
	; Other registers can be saved on the stack using
	; TAX and TAY before PHA
	ldx #1
	ldy #2
	txa             ; Save X
	pha
	tya             ; Save Y
	pha
	
	; They can be restored likewise
	pla             ; Restore Y
	tay
	pla             ; Restore X
	tax
	
	jsr print_x     ; prints 02
	jsr print_y     ; prints 01
	jsr print_newline
	
	rts

; Routine that uses A, but first saves its previous value
; Preserved: A
routine:
	; First save A
	pha
	
	lda #2
	jsr print_a
	
	; Restore A as it was when routine began
	pla
	rts
