; Writes and reads memory

.include "shell.inc"

main:
	; Registers can be written to memory
	lda #$12
	ldx #$34
	ldy #$56
	sta $700        ; write $12 to memory at $700
	stx $701        ; write $34 to memory at $701
	sty $702        ; write $56 to memory at $702
	
	; Memory can be read into registers
	ldy $700        ; Y = byte in memory at $700
	ldx $701        ; X = byte in memory at $701
	lda $702        ; A = byte in memory at $702
	jsr print_y     ; prints 12
	jsr print_x     ; prints 34
	jsr print_a     ; prints 56
	jsr print_newline
	
	; Using indexed addressing and a loop, multiple
	; bytes can be accessed
	ldx #0
loop:   lda $700,x      ; A = byte in memory at $700+X
	jsr print_a
	inx
	cpx #3
	bne loop
	jsr print_newline
	
	rts
