//this example shows virtual brightness control, press up or down to change the brightness

#include "neslib.h"

#include "test.h"	//packed nametable data

const unsigned char palette[16]={ 0x0f,0x21,0x10,0x30,0x0f,0x14,0x21,0x31,0x0f,0x29,0x16,0x26,0x0f,0x09,0x19,0x29 };	//palette data


void main(void)
{
	static unsigned char i,bright;
	
	//rendering is disabled at the startup, and palette is all black
	
	pal_bg(palette);//set background palette from an array

	unrle_vram(test,0x2000);//unpack nametable into the VRAM

	ppu_on_all();//enable rendering

	bright=4;//normal bright
	
	while(1)
	{
		pal_bright(bright);
		ppu_waitnmi();
		
		i=pad_trigger(0);
		
		if(i&PAD_UP)   if(bright<8) ++bright;
		
		if(i&PAD_DOWN) if(bright>0) --bright;
	}
}